<section class="content-header">
  <h1 class="page-head-line">SCHEDULES | <small>{{schedule.schedule_code}}</small> </h1>
</section>
<section class="content">

  <div class="container">
    <div class="row justify-content-center">

      <div class="col-md-12 p-md-0 pr-md-4">

        <div *ngIf="access">
          <div class="row">
            <div class="col-md-4 col-sm-8 mb-4">
              <input type='text' name="search" [(ngModel)]="search" (keyup)='updateFilter()' class="form-control form-control-sm mb-0"
                placeholder='Seach here' />
            </div>

            <div class="col-md-8 col-sm-4 mb-4">
              <button class="btn btn-flat bk-clr-three btn-sm text-white float-right" (click)="add(content)" type="button">
                <span class="fa fa-plus"></span>
                Add
              </button>
            </div>
          </div>

          <ngx-datatable class="material mb-4" [rows]="schedule.lines" [loadingIndicator]="loading" [columnMode]="'force'" [headerHeight]="45"
            [footerHeight]="40" [rowHeight]="'auto'" [limit]="5">

            <ngx-datatable-column name="Schedule code">
              <ng-template ngx-datatable-cell-template>
                {{ schedule.schedule_code }}
              </ng-template>
            </ngx-datatable-column>
            <ngx-datatable-column prop="from_time" name="From"></ngx-datatable-column>
            <ngx-datatable-column prop="to_time" name="To"></ngx-datatable-column>
            <ngx-datatable-column prop="subject.subject_code" name="Subject code"></ngx-datatable-column>
            <ngx-datatable-column prop="subject.subject_name" name="Subject name"></ngx-datatable-column>
            <ngx-datatable-column name="Teacher">
              <ng-template let-row="row" ngx-datatable-cell-template>
                {{ getTeachername(row.teacher)}}
              </ng-template>
            </ngx-datatable-column>
            <ngx-datatable-column prop="room.room_name" name="Room"></ngx-datatable-column>


            <ngx-datatable-column name="Action" [headerClass]="'text-center'" [cellClass]="'text-center'">
              <ng-template let-row="row" ngx-datatable-cell-template>
                <button *ngIf="access && access.can_edit" type="button" class="btn btn-link mr-2" (click)="edit(row,content)">
                  <span title="Edit" class="fa fa-edit"></span>
                </button>
                <button *ngIf="access && access.can_delete" type="button" class="ml-auto btn btn-link btn-sm text-white mr-2" placement="top"
                  [ngbPopover]="popDeleteContent" [popoverTitle]="popDeleteTitle" container="body" #deletePop="ngbPopover">
                  <span class="fa fa-trash text-red"></span>
                </button>

                <ng-template #popDeleteTitle>
                  <small>
                    <b>
                      Confirm delete
                    </b>
                  </small>
                </ng-template>

                <ng-template #popDeleteContent>

                  <p>Are you sure you want to delete this schedule line?</p>
                  <div class="d-flex my-2">

                    <div class="ml-auto">
                      <button type="button" class="btn btn-link px-2" (click)="delete(row.id)" data-toggle="tooltip" data-placement="bottom" title="Yes">
                        <span class="fa fa-check text-green"></span>
                      </button>
                      <button type="button" class="btn btn-link px-2" data-toggle="tooltip" data-placement="bottom" title="No">
                        <span class="fa fa-times text-red"></span>
                      </button>
                    </div>

                  </div>
                </ng-template>
              </ng-template>
            </ngx-datatable-column>
          </ngx-datatable>
        </div>

      </div>
    </div>
  </div>

</section>


<ng-template #content let-modal let-c="close">
  <form *ngIf="obj" #objForm=ngForm (ngSubmit)="save()" class="mb-0">
    <div class="modal-header">
      <h4 class="modal-title">Schedule line</h4>
      <button type="button" class="btn btn-link text-secondary" aria-label="Close" (click)="dismiss()">
        <span class="fa fa-times"></span>
      </button>
    </div>
    <div class="modal-body">
      <div class="form-row justify-content-center pt-4 mt-2">
        <div class="form-group">

          <div class="input-group">
            <div class="col-md-6">
              <input [(ngModel)]="obj.from_time" name="from_time" [ngxTimepicker]="frompicker" type="text" class="form-control form-control-sm"
                placeholder="From">
              <span class="text-danger" [hidden]="!error.from_time">{{ error.from_time }}</span>

              <ngx-material-timepicker #frompicker></ngx-material-timepicker>
            </div>

            <div class="col-md-6">
              <input [(ngModel)]="obj.to_time" name="to_time" [ngxTimepicker]="topicker" type="text" class="form-control form-control-sm"
                placeholder="To">
              <span class="text-danger" [hidden]="!error.subject_id">{{ error.to_time }}</span>

              <ngx-material-timepicker #topicker></ngx-material-timepicker>
            </div>

          </div>
        </div>
      </div>
      <div class="form-group">
        <select [(ngModel)]="obj.subject_id" name="subject_id" class="form-control form-control-sm">
          <option [ngValue]="null">Select subject</option>
          <option *ngFor="let a of subjects" [ngValue]="a.id">{{ a.subject_name }}</option>
        </select>
        <span class="text-danger" [hidden]="!error.subject_id">{{ error.subject_id }}</span>
      </div>
      <div class="form-group">
        <select [(ngModel)]="obj.teacher_id" name="teacher_id" class="form-control form-control-sm">
          <option [ngValue]="null">Select teacher</option>
          <option *ngFor="let a of teachers" [ngValue]="a.id">{{ a.getFullname() }}</option>
        </select>
        <span class="text-danger" [hidden]="!error.teacher_id">{{ error.teacher_id }}</span>
      </div>
      <div class="form-group">
        <select [(ngModel)]="obj.room_id" name="room_id" class="form-control form-control-sm">
          <option [ngValue]="null">Select room</option>
          <option *ngFor="let r of rooms" [ngValue]="r.id">{{ r.room_name }}</option>
        </select>
        <span class="text-danger" [hidden]="!error.room_id">{{ error.room_id }}</span>
      </div>

    </div>
    <div class="modal-footer">
      <div class="form-group float-right mt-2 mb-1">
        <button type="submit" [disabled]="!objForm.valid" class="btn btn-primary btn-flat btn-sm">
          <span class="fa fa-save"></span>
          Save
        </button>
        <button type="button" (click)="cancel()" class="btn btn-danger btn-flat btn-sm">
          <span class="fa fa-times"></span>
          Cancel
        </button>
      </div>
    </div>
  </form>
</ng-template>